SystemOrganization addCategory: #'tODE-AmberDebugger'!

!TOAmberErrorHandler methodsFor: '*tode-amberdebugger' stamp: 'dkh 10/24/2011 09:46'!
open: anException
    | renderer |
    [ 
    false
        ifTrue: [ super open: anException ].
    renderer := (TOAmberFrameComponent new)
        object:
                ((TOADebugger new)
                        exception: anException;
                        yourself);
        target: '_blank';
        yourself.
    self session presenter object: anException.
    self session presenter call: renderer onAnswer: [ self halt ] ] on: Error do: [ :ex | super open: ex ]! !

Object subclass: #TOADebugger
	instanceVariableNames: 'exception frames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-AmberDebugger'!

!TOADebugger methodsFor: 'private' stamp: 'dkh 10/24/2011 09:39'!
createFrames
    | context frame next |
    frames := OrderedCollection new.
    context := exception signalerContext.
    frame := (TOAFrame new)
        context: context;
        debugger: self;
        yourself.
    [ context isNil ]
        whileFalse: [ 
            frames add: frame.
            context := context sender.
            context
                ifNotNil: [ 
                    next := (TOAFrame new)
                        context: context;
                        debugger: self;
                        yourself.
                    frame next: next.
                    next previous: frame.
                    frame := next ] ]! !

!TOADebugger methodsFor: 'accessing' stamp: 'dkh 10/24/2011 09:40'!
exception
    ^exception! !

!TOADebugger methodsFor: 'accessing' stamp: 'dkh 10/24/2011 09:39'!
exception: anException
    exception := anException.
    self createFrames! !

!TOADebugger methodsFor: 'accessing' stamp: 'dkh 10/24/2011 09:40'!
frames
    ^frames! !

Object subclass: #TOAFrame
	instanceVariableNames: 'debugger prev next method context receiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-AmberDebugger'!

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 09:45'!
context: aMethodContext

	context := aMethodContext.
	receiver := context receiver.
	method := MethodReference class: context method classBinding selector: context method selector! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 09:40'!
debugger: aTOADebugger

	debugger := aTOADebugger! !
